#!/usr/bin/env python3

import os

import numpy as np
import scipy.optimize
import matplotlib.pyplot as plt


def nicer_fsolve(F, initial_guess):
    """Wrapper for `scipy.optimize.fsolve`.

    This wrapper is used to solve non-linear equations of multidimensial arrays.
    """
    shape = initial_guess.shape

    initial_guess = initial_guess.reshape((-1,))
    result = scipy.optimize.fsolve(
        lambda x: F(x.reshape(shape)).reshape((-1)), initial_guess
    )

    return result.reshape(shape)



# TODO vervollständigen Sie das Template.


y0 = np.array([0.35502805388781723926, -0.25881940379280679841])



# TODO vervollständigen Sie das Template.



def y_exact(t):
    """Returns the exact solution of the ODE.

    Time runs along the first axis and [y, dy/dt] are arranged along the second
    axis.
    """
    # Only Ai is needed, however, scipy.special.airy also returns Bi.
    return np.array(scipy.special.airy(t)[:2])


def plot_solution(t, y, label):
    plt.figure()
    plt.plot(t, y_exact(t)[0], "r", label="Exact")
    plt.plot(t, y[0, :], "b", label=label)
    plt.grid(True)
    plt.xlabel("t")
    plt.ylabel("Ai(t)")
    plt.legend(loc="best")
    plt.savefig(f"img/ai_{label}.png")



# TODO vervollständigen Sie das Template.

